import { pluginUtils, searchUtils } from '@verdaccio/core';
import { Logger, Token } from '@verdaccio/types';
import MemoryHandler, { DataHandler } from './memory-handler';
export type ConfigMemory = {
    limit?: number;
};
export interface MemoryLocalStorage {
    secret: string;
    list: string[];
    files: DataHandler;
}
declare class LocalMemory extends pluginUtils.Plugin<ConfigMemory> implements pluginUtils.Storage<ConfigMemory> {
    private path;
    private limit;
    logger: Logger;
    private data;
    config: ConfigMemory;
    constructor(config: ConfigMemory, options: pluginUtils.PluginOptions);
    init(): Promise<void>;
    getSecret(): Promise<string>;
    setSecret(secret: string): Promise<string | null>;
    add(name: string): Promise<void>;
    search(query: searchUtils.SearchQuery): Promise<searchUtils.SearchItem[]>;
    remove(name: string): Promise<void>;
    get(): Promise<any>;
    getPackageStorage(packageInfo: string): MemoryHandler;
    hasTarball(): Promise<boolean>;
    hasPackage(): Promise<boolean>;
    private _createEmtpyDatabase;
    saveToken(): Promise<void>;
    deleteToken(user: string, tokenKey: string): Promise<void>;
    readTokens(): Promise<Token[]>;
}
export default LocalMemory;
