/// <reference types="node" />
import { PassThrough, Writable } from 'stream';
import { pluginUtils } from '@verdaccio/core';
import { Logger, Manifest } from '@verdaccio/types';
export type DataHandler = {
    [key: string]: string;
};
declare class MemoryHandler implements pluginUtils.StorageHandler {
    private data;
    private name;
    private path;
    logger: Logger;
    constructor(packageName: string, data: DataHandler, logger: Logger);
    hasTarball(fileName: string): Promise<boolean>;
    hasPackage(): Promise<boolean>;
    deletePackage(pkgName: string): Promise<void>;
    removePackage(): Promise<void>;
    createPackage(name: string, value: Manifest): Promise<void>;
    savePackage(name: string, value: Manifest): Promise<void>;
    readPackage(name: string): Promise<Manifest>;
    writeTarball(name: string): Promise<Writable>;
    readTarball(pkgName: string, { signal }: {
        signal: any;
    }): Promise<PassThrough>;
    private _getStorage;
    updatePackage(packageName: string, handleUpdate: (manifest: Manifest) => Promise<Manifest>): Promise<Manifest>;
}
export default MemoryHandler;
